/*
 * ===========================
 * VDK Builder
 * Version 0.1.1
 * Revision 0.0
 * March 1999
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library 
 * Copyright (C) 1998, Mario Motta
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
#ifndef _vdkb_handlebox_h
#define _vdkb_handlebox_h

#include <vdkb/vdkb_evcontain.h>
#include <vdkb/vdkb_evbox.h>
#include <vdk/menu.h>
#include <vdk/handlebox.h>


class VDKBGuiForm;
class VDKBParser;
class VDKBObjectInspector;

class VDKBHandleBox: public VDKBEventContainer
{
 protected:
  VDKHandleBox* handlebox;
  VDKMenuItem *delBox;
  VDKMenuItem *delwidget,*setsize;
  // property controls used by object inspector
  VDKSpinButton* border;
  VDKLabelButton* set;
  VDKBObjectInspector* inspector; // object inspector
  void Init();
 public:
  static int Counter;
  static int MakeWidget(VDKBGuiForm* owner, GdkEvent* ev = NULL);
  static char* CreateSource(char* buffer,VDKBParser& parser);
  static bool CreateWidget(VDKBGuiForm* owner, 
			   char* buffer,VDKBParser& parser);
  VDKObjectContainer*  ExtraWidget(VDKBObjectInspector* isp);
  bool OnBorderWidth(VDKObject*);
  void WriteOnFrm(FILE* fp, VDKBObject* parentobj);
  VDKBHandleBox(char* name, VDKForm* owner);
  VDKBHandleBox(char* name, VDKBEventContainer* outer);
  virtual ~VDKBHandleBox() {}
  void AddBox();
  void PopMenu() { popmenu->Popup(); }
  void Add(VDKObject* wid, int justify,
			int expand, int fill , int padding,
			bool forceArgs);
  bool DelBox(VDKObject* sender);

  virtual int Type() { return vdkbhandlebox_class; }

  virtual int isA() { return vdkbhandlebox_class; }

  void AddWidget(VDKObject* w, int justify = l_justify,
		 int expand = TRUE, int fill = TRUE , 
		 int padding = 0, bool forceArgs = false);

  virtual char* VDKName() { return "VDKHandleBox"; }
  bool SetBoxSize(VDKObject* sender);
  // designer
  DECLARE_EVENT_LIST(VDKBHandleBox);
  DECLARE_SIGNAL_LIST(VDKBHandleBox);
};

#endif

